{ WebEng unit for search engine analysis
  (C)2000/2001 by gerd@dg4fac.de Version 0.8
  created 04.09.2000 for fpk-Pascal under
  SuSe-Linux 7.0, last change 05.01.2002
}

Unit webeng;

Interface
Uses SysUtils,WebList,WebString;

Function CheckEng(s:String):Boolean;

Implementation

Const
  nterms=28;
  sterms:Array[1..nterms] Of String[15] = ('q=','s=','as_q=','ask=','general=',
    'key=','Keywords=','keywords=','keyword=','MT=','p=','qr=','qry=','qs=',
    'qt=','query=','QUERY=','SearchTerms=','search=','soegord=','srch=',
    'string=','su=','szukaj=','terms=','uri=','url=','words=');


Function Hex2Byte(c:Char):Byte;
Begin
If (c>='0') And (c<='9') Then
  Hex2Byte:=Byte(c)-48 Else
  Begin
  If (c>='A') And (c<='F') Then
    Hex2Byte:=Byte(c)-55 Else
    Hex2Byte:=255;
  End;
End;

Function Hex2Char(c1,c2:Char):Char;
Var b1,b2:Byte;
Begin
b1:=Hex2Byte(c1);
b2:=Hex2Byte(c2);
If (b1<>255) And (b2<>255) Then
  Hex2Char:=Char(16*b1+b2) Else
  Hex2Char:='?';
End;

Procedure Exchange(Var s1:String;p:LongInt);
Begin
s1[p]:=Hex2Char(s1[p+1],s1[p+2]);
Delete(s1,p+1,2);
End;

Function CheckEng(s:String):Boolean;
Var sa,ss:String;
    cv:Char;
    b,ls,nf,kp:Byte;
    found:Boolean;
Begin
CheckEng:=False;
ls:=Length(s);
If ls>7 Then
  Begin
  If Copy(s,1,7)='http://' Then
    Begin
    b:=8;
    Repeat Inc(b) Until (b>ls) Or (s[b]='/');
    If b<=ls Then
      Begin
      sa:=Copy(s,1,b-1);
      ss:=Copy(s,b+1,255);
      If ss<>'' Then
        Begin
        nf:=0;
        found:=False;
        Repeat
          Inc(nf);
          kp:=Pos(sterms[nf],ss);
          If kp>0 Then
            Begin
            cv:=ss[kp-1];
            found:=(cv='?') Or (cv='&');
            End;
          Until found Or (nf=nterms);
        If found Then
          Begin
          ss:=Copy(ss,kp+Length(sterms[nf]),255);
          kp:=Pos('&',ss);
          If kp>0 Then ss:=Copy(ss,1,kp-1);
          While Pos('+',ss)>0 Do ss[Pos('+',ss)]:=' ';
          While Pos('%',ss)>0 Do Exchange(ss,Pos('%',ss));
          x.s:=sa;
          x.n:=1;
          ListAddNew(ListSE);
          x.s:=ss;
          ListAddNew(ListST);
          CheckEng:=True;
          End;
        End;
      End;
    End;
  End;
End;

End.

