Unit webstring;

Interface
Const
  nGroups=7;
  sWsGroups:Array[1..ngroups] Of String=('Return codes','Lists',
    'Sort options','Hosts','Messages','HTML',
    'End of configuration file');
  rcGroup=1;
  tGroup=2;
  sortGroup=3;
  hostGroup=4;
  msgGroup=5;
  htmlGroup=6;
  
Type
  TFromTo=Record
    ia,ie:LongInt;
    End;
  
Var
  ws:Array[0..200] Of String;
  igrpws:Array[1..ngroups] Of TFromTo;
  ircla,lang,nws:LongInt;
  sLangFile:String;

Procedure ReadLangStrings;

Implementation
Uses Crt,weberr;

Procedure ReadLangStrings;
Var f:Text;
  i,k:LongInt;
  s:String;
Begin
Write('Read language in ',sLangFile,' ... ');
Assign(f,sLangFile);
Reset(f);
nws:=0;
i:=0;
While Not Eof(f) Do
  Begin
  Readln(f,s);
  If s<>'' Then
    Begin
    If s[1]='[' Then
      Begin
      k:=0;
      Repeat Inc(k) Until (k>nGroups) Or (Pos(sWsGroups[k],s)>0);
      If k>ngroups Then
        Begin
        Writeln('Unknown group ',s);
        WebErrOut(sLangFile,'Unknown group '+s);
        WebErrClose;
        ReadKey;
        Halt(5);
        End;
      If i<>0 Then igrpws[i].ie:=nws;
      i:=k;
      igrpws[i].ia:=nws+1;
      End Else
      Begin
      Inc(nws);
      ws[nws]:=s;
      End;
    End;
  End;
Close(f);
Writeln('done.');
End;

Begin
End.

